// ===============================================================================================
package mahjongg;

import javax.swing.*;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JButton;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Hashtable;

// -----------------------------------------------------------------------------

public class main
{ 
  final static String gname="MahJongg",kenn="mahjongg";
  final static String commands[] ={ "neu","alt","cont","zeigezug","zeigerest","savesettings","quit",
                                    "patterns","tileset","background","sound","hilfe","about","back","lang" };
  final static String datenpfad=kenn+"/data/"; // Jar-Ressourcen
  final static String configfile="game.ini";   // Muster: Schluessel=Wert, oder nur Schluessel fuer bool=true

  static String lang;         // Language kennung, derzeit en oder deu
  static String langtext[];   // Beschriftung fuer Menus
  static String hilfetext[];  // Hilfetexte
  static String background[]; // Hintergruende, Muster: Titel,Dateiname
  static String tileset[];    // Steine, Muster: Titel,Dateiname
  static String pattern[];    // Bretter, Muster: Titel,Dateiname
  static Hashtable<String,String> langdef=new Hashtable<String,String>();

  static int kommando=-1,patternid=0,tileid=0,backgroundid=0,soundid=0; // Initialisierung ini-Variable
  static JFrame frame=new JFrame(gname);
  static JCheckBoxMenuItem sou_on=new JCheckBoxMenuItem("Sound");  // wird von spiel gesteuert
  static JMenuItem zugback;                                        // muss von spiel gesteuert werden
  static JScrollPane jsp =new JScrollPane();                       // Scrollbars
  static JPanel zwischenlager=new JPanel();  // jsp arbeitet nur mit "reinrassigen" JPanels zusammen

  static main self=new main();                                     // pointer fuer Signalweg
  static spielfeld gamepanel=new spielfeld(self);                  // als parent fuer Signalweg uebergeben
  static spiel my_spiel=new spiel(self);                           // als parent fuer Signalweg uebergeben

// Listeners: ----------------------------------------------------------------------------------------------------------
  static ActionListener alist=new ActionListener() { public void actionPerformed(ActionEvent e) { buttonklick(e); } };
  static MouseAdapter mausdap=new MouseAdapter() { public void mousePressed(MouseEvent e){ klick(e.getX(),e.getY()); } };

// Methoden: ---------------------------------------------------------------------------------------------------------
  public static void main(String[] args) 
  { // sonst "vergisst" Java die Haelfte (nicht threadsicher!)
    javax.swing.SwingUtilities.invokeLater(new Runnable()
    { public void run()
      { load_config(); init_gui(); set_options();
        gamepanel.set_screen(0); my_spiel.neu(true); // vom Kunden so gewuenscht
      }
    }
    ); 
  }

// slots:
  static String get_kennung()   { return kenn; }
  static String get_spielname() { return gname; }
  static String get_pattname()  { String[] t2=pattern[patternid].split(","); return t2[0]; }
  static String get_backname()  { String[] t2=background[backgroundid].split(","); return t2[0]; }
  static String get_tilename()  { String[] t2=tileset[tileid].split(","); return t2[0]; }
  static void popup(String t)   { JOptionPane.showMessageDialog(null,t,"Info:",JOptionPane.INFORMATION_MESSAGE); }

  static void save_options()
  { String raus="lang="+lang+"\n";
    raus=raus+"soundon="+soundid+"\n";
    raus=raus+"background="+backgroundid+"\n";
    raus=raus+"pattern="+patternid+"\n";
    raus=raus+"tileset="+tileid+"\n";
    savefile(configfile,raus);
  }

  int[][] load_pattern(String pattfile) // 144 Koordinaten x,y,z aus jar-File
  { int i,j,k;
    int[][]feld=new int[my_spiel.maxsprites][3];
    String[] koo=new String[3];
    String patt=pattfile;
    String zeile[]=get_lines(datenpfad+patt);
    for (i=0; i<zeile.length; i++)
    { koo=zeile[i].split(",");
      feld[i][0]=Integer.parseInt(koo[0]);
      feld[i][1]=Integer.parseInt(koo[1]);
      feld[i][2]=Integer.parseInt(koo[2]);
    }
    return feld;
  }

// ----------------------------------------------------------------------------------------------------------------
// main-Interna:
// ----------------------------------------------------------------------------------------------------------------
  static void init_gui() // scrollbares Window mit Zeichenflaeche
  { // liefert falsche Werte an JScrollPane:
    gamepanel.addMouseListener(mausdap);
    gamepanel.setPreferredSize(new Dimension(gamepanel.sxmax,gamepanel.symax));
    // deshalb dieses Zwischenpanel:
    zwischenlager.setLayout(new BorderLayout()); 
    zwischenlager.add(gamepanel,BorderLayout.CENTER);
    zwischenlager.setPreferredSize(new Dimension(gamepanel.sxmax,gamepanel.symax));
    jsp.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    jsp.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
    jsp.setViewportView(zwischenlager);
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.setJMenuBar(mach_menubar());
    frame.add(jsp,BorderLayout.CENTER);
    frame.setSize(800,600); // Startgroesse
    frame.setVisible(true);
  }

// ---------------------------------------------------------------------------------------

  static JMenuBar mach_menubar()
  { int i;
    String[] temp;
    JMenuBar menu=new JMenuBar();
    menu.setLayout(new FlowLayout(FlowLayout.LEFT,32,0));
    // Dropdown Menus Headers:
    JMenu menu0=new JMenu(langdef.get("GAME"));     menu.add(menu0);
    JMenu menu1=new JMenu(langdef.get("OPTIONS"));  menu.add(menu1);
    JMenu menu3=new JMenu(langdef.get("LANGUAGE")); menu.add(menu3);
    JMenu menu2=new JMenu(langdef.get("INFO"));     menu.add(menu2);
    // Dropdown Menu 0: -------------------------------------------------------------------
    JMenuItem neu = new JMenuItem(langdef.get("NEW"),KeyEvent.VK_N);
    neu.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N,InputEvent.CTRL_MASK));
    neu.addActionListener(alist);
    neu.setActionCommand(commands[0]);
    menu0.add(neu);
    JMenuItem alt = new JMenuItem(langdef.get("RESTART"),KeyEvent.VK_V);
    alt.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V,InputEvent.CTRL_MASK));
    alt.addActionListener(alist);
    alt.setActionCommand(commands[1]);
    menu0.add(alt);
    JMenuItem cont = new JMenuItem(langdef.get("CONT"),KeyEvent.VK_F);
    cont.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F,InputEvent.CTRL_MASK));
    cont.addActionListener(alist);
    cont.setActionCommand(commands[2]);
    menu0.add(cont);
    menu0.addSeparator();
    zugback= new JMenuItem(langdef.get("BACK"),KeyEvent.VK_B);
    zugback.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_B,InputEvent.CTRL_MASK));
    zugback.setActionCommand(commands[13]);
    zugback.addActionListener(alist);
    menu0.add(zugback);
    JMenuItem zuege = new JMenuItem(langdef.get("MOVES"),KeyEvent.VK_Z);
    zuege.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z,InputEvent.CTRL_MASK));
    zuege.setActionCommand(commands[3]);
    zuege.addActionListener(alist);
    menu0.add(zuege);
    JMenuItem rest = new JMenuItem(langdef.get("REST"),KeyEvent.VK_R);
    rest.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R,InputEvent.CTRL_MASK));
    rest.setActionCommand(commands[4]);
    rest.addActionListener(alist);
    menu0.add(rest);
    menu0.addSeparator();
    JMenuItem quit = new JMenuItem(langdef.get("QUIT"),KeyEvent.VK_Q);
    quit.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q,InputEvent.CTRL_MASK));
    quit.addActionListener(alist);
    quit.setActionCommand(commands[6]);
    menu0.add(quit);
    // Optionen und deren Submenus: -------------------------------------------------------------------------------
    sou_on.addActionListener(alist);
    sou_on.setActionCommand(commands[10]);
    menu1.add(sou_on);
    JMenu sub1=new JMenu(langdef.get("LAYOUT"));
    JMenuItem[] jmi_patt=new JMenuItem[pattern.length];
    for (i=0; i<pattern.length; i++)
    { temp=pattern[i].split(","); 
      jmi_patt[i]=new JMenuItem(temp[0]);
      jmi_patt[i].addActionListener(alist);
      jmi_patt[i].setActionCommand(commands[7]+"-"+i); // hier keinen Punkt nehmen, split ist da buggy
      sub1.add(jmi_patt[i]);
    }
    menu1.add(sub1);
    JMenu sub2=new JMenu(langdef.get("TILES"));
    JMenuItem[] jmi_tiles=new JMenuItem[tileset.length];
    for (i=0; i<tileset.length; i++)
    { temp=tileset[i].split(","); 
      jmi_tiles[i]=new JMenuItem(temp[0]);
      jmi_tiles[i].addActionListener(alist);
      jmi_tiles[i].setActionCommand(commands[8]+"-"+i);
      sub2.add(jmi_tiles[i]);
    }
    menu1.add(sub2);
    JMenu sub3=new JMenu(langdef.get("BACKGR"));
    JMenuItem[] jmi_backgr=new JMenuItem[background.length];
    for (i=0; i<background.length; i++)
    { temp=background[i].split(","); 
      jmi_backgr[i]=new JMenuItem(temp[0]);
      jmi_backgr[i].addActionListener(alist);
      jmi_backgr[i].setActionCommand(commands[9]+"-"+i);
      sub3.add(jmi_backgr[i]);
    }
    menu1.add(sub3);
    menu1.addSeparator();
    JMenuItem save = new JMenuItem(langdef.get("SAVEOPT"),KeyEvent.VK_S);
    save.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,InputEvent.CTRL_MASK));
    save.setActionCommand(commands[5]);
    save.addActionListener(alist);
    menu1.add(save);
    // Sprachen: -------------------------------------------------------------------------
    JMenuItem lang_deu = new JMenuItem("Deutsch (Neustart erforderlich)");
    lang_deu.setActionCommand(commands[14]+"-0");
    lang_deu.addActionListener(alist);
    menu3.add(lang_deu);
    JMenuItem lang_en = new JMenuItem("English (needs restart)");
    lang_en.setActionCommand(commands[14]+"-1");
    lang_en.addActionListener(alist);
    menu3.add(lang_en);
    // Infos: ----------------------------------------------------------------------------
    JMenuItem hilfe = new JMenuItem(langdef.get("HELP"),KeyEvent.VK_H);
    hilfe.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_H,InputEvent.CTRL_MASK));
    hilfe.setActionCommand(commands[11]);
    hilfe.addActionListener(alist);
    menu2.add(hilfe);
    JMenuItem about = new JMenuItem(langdef.get("ABOUT"),KeyEvent.VK_A);
    about.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A,InputEvent.CTRL_MASK));
    about.setActionCommand(commands[12]);
    about.addActionListener(alist);
    menu2.add(about);
    return menu;
  }

  // ini-Files lesen und auswerten ----------------------------------------------------------
  static void load_config()
  { int i;
    String t;
    String temp[]=new String[2];
    String rec[]=loadfile(configfile).split("\n");
    soundid=0;
    lang="deu";
    for (i=0; i<rec.length; i++)
    { temp=rec[i].split("=");
      if (temp.length>1) t=temp[1]; else t="0";
      if (temp[0].equals("soundon")) soundid=Integer.parseInt(t);
      else if (temp[0].equals("lang")) lang=t;
      else if (temp[0].equals("background")) backgroundid=Integer.parseInt(t);
      else if (temp[0].equals("tileset")) tileid=Integer.parseInt(t);
      else if (temp[0].equals("pattern")) patternid=Integer.parseInt(t);
    }
    rec=get_lines(datenpfad+"lang_"+lang+".def");
    for (i=0; i<rec.length; i++)
    { temp=rec[i].split("=");
      langdef.put(temp[0],temp[1]);
    }
    hilfetext =get_lines(datenpfad+"hilfe_"+lang+".txt");
    background=get_lines(datenpfad+"background_"+lang+".lst");
    tileset   =get_lines(datenpfad+"tileset_"+lang+".lst");
    pattern   =get_lines(datenpfad+"pattern_"+lang+".lst"); 
 }

  static void set_options()
  { String[] tfeld;
    sou_on.setSelected((soundid>0));           my_spiel.set_sound((soundid>0));
    tfeld=pattern[patternid].split(",");       my_spiel.set_pattern(tfeld[1]);
    tfeld=tileset[tileid].split(",");          gamepanel.set_tileset(tfeld[1]);
    tfeld=background[backgroundid].split(","); gamepanel.set_background(tfeld[1]);
  }

// --------------------------------------------------------------------------------------------------------
// Dateien und Ressourcen laden, speichern
// --------------------------------------------------------------------------------------------------------
  static String[] get_lines(String filnam) { return (loadressource(filnam)).split("\n"); }

  static String loadfile(String infile)
  { String s,t="";
    try
   { BufferedReader in=new BufferedReader(new InputStreamReader(new FileInputStream(infile), "UTF8"));
     do { s=in.readLine(); if (s!=null) t=t+s+"\n"; } while (s!=null);
     in.close();
   }
   catch (IOException e) { System.out.println(">>>Could not find "+infile+"!\n(Check game.ini)"); }
   return t;
  }

 static String loadressource(String infile)
 { String s,t="";
   try
   { InputStream ips= main.class.getClassLoader().getResourceAsStream(infile);
     BufferedReader in = new BufferedReader(new InputStreamReader(ips,"UTF8"));
     do { s=in.readLine(); if (s!=null) t=t+s+"\n"; } while (s!=null);
     in.close();
   }
   catch (NullPointerException e) { System.out.println("Ressource "+infile+" not found"); }
   catch (IOException e) { System.out.println("Ressource "+infile+" not found or faulty!"); }
   return t;
 }

 static void savefile(String outfil,String inhalt)
 { try
   { BufferedWriter out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(outfil), "UTF8"));
     out.write(inhalt);
     out.close();
   }
   catch (UnsupportedEncodingException e) { System.out.println("Sorry, no UTF-8!"); }
   catch (IOException e) { System.out.println("Sorry, Could not write "+outfil); }
 }

// ------------------------------------------------------------------------------------------------------
// Event-Handling:
// ------------------------------------------------------------------------------------------------------
  static public void buttonklick(ActionEvent e)
  { int i,ind=0;
    String temp;
    String[] tfeld=new String[2];
    kommando=-1;
    for (i=0; i<commands.length; i++)  if (commands[i] .equals(e.getActionCommand())) kommando=i;
    if (kommando<0)
    { tfeld=e.getActionCommand().split("-");
      for (i=0; i<commands.length; i++) if (commands[i] .equals(tfeld[0]))
      { kommando=i;
        ind=Integer.parseInt(tfeld[1]);
      }
    }
    switch(kommando)
    { case 0: gamepanel.set_screen(0); my_spiel.neu(true); break;
      case 1: gamepanel.set_screen(0); my_spiel.neu(false); break;
      case 2: gamepanel.set_screen(0); break;
      case 3: gamepanel.set_screen(0); my_spiel.zeige_zuege(); break;
      case 4: gamepanel.set_screen(1); break;
      case 5: save_options(); break;
      case 6: aufraeumen(); break;
      case 7: patternid=ind;
              tfeld=pattern[ind].split(",");
              my_spiel.set_pattern(tfeld[1]);
              my_spiel.neu(true);
              break;
      case 8: tileid=ind;
              tfeld=tileset[ind].split(",");
              gamepanel.set_tileset(tfeld[1]);
              break;
      case 9: backgroundid=ind;
              tfeld=background[ind].split(",");
              gamepanel.set_background(tfeld[1]);
              break;
      case 10: if (sou_on.isSelected()) soundid=1; else soundid=0; my_spiel.set_sound(soundid>0); break;
      case 11: gamepanel.set_screen(2); break; // hilfe
      case 12: popup("Java MahJongg\nAutor: uja\nVersion 1.0-int (16.12.2007)"); break;
      case 13: gamepanel.set_screen(0); my_spiel.zugback(); break;
      case 14: switch (ind)
               { case 1:  lang="en"; break;
                 default: lang="deu";
               }
               save_options();
               break;
      default: gamepanel.set_screen(-1); // Titelbild
    }
    gamepanel.repaint();
  }

  public static void klick(int mx,int my) { my_spiel.klick(mx,my); gamepanel.repaint(); }
  public static void aufraeumen() { my_spiel.zaund.close_soundall(); System.exit(0); }

}
